#!/usr/bin/perl

use strict;
use warnings;

do 'bin/make.pl';

sub make_stub_function($%)
{
	our $api;
	
	print "static " . $_[1]->{rtype} . " " . $api . " " . prefixname($_[0]) . "_stub(" .
		$_[1]->{parms} . ")\n{\n  _glewInitFunctionLoader();\n  _glewInit_" .
		$_[2] . "(GLEW_CONTEXT_ARG_VAR_INIT);\n  ";
	if ( (uc $_[1]->{rtype}) ne "void" )
	{
		print "return ";
	}
	print prefixname($_[0]) . "(";
	my @parms = split(/[ ,*]+/, $_[1]->{parms});
	my $idx;
	if (@parms > 1)
	{
		print $parms[1];
		for ($idx = 3; $idx < @parms; $idx+=2)
		{
			print ", " . $parms[$idx];
		}
	}
	print ");\n}\n";
	print "PFN" . (uc $_[0]) . "PROC " . prefixname($_[0]) . " = " . prefixname($_[0]) . "_stub;\n\n";
}

my @extlist = ();
our $api = shift;

if (@ARGV)
{
    @extlist = @ARGV;

	foreach my $ext (sort @extlist)
	{
		my ($extname, $exturl, $types, $tokens, $functions, $exacts) =
			parse_ext($ext);

		print "#ifdef $extname\n\n";
		if (keys %$functions)
		{
			foreach my $func (sort keys %$functions)
			{
				make_stub_function($func, $functions->{$func}, $extname);
			}
		}
		print "#endif /* $extname */\n\n";
	}
}
